"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _ThreeEsMin = require("../../node_modules/three-full/builds/Three.es.min.js");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PDBView =
/*#__PURE__*/
function (_Component) {
  _inherits(PDBView, _Component);

  function PDBView(props) {
    var _this;

    _classCallCheck(this, PDBView);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PDBView).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "startRendering", function () {
      var width = _this.mount.clientWidth;
      var height = _this.mount.clientHeight;
      var scene = new _ThreeEsMin.Scene();
      var camera = new _ThreeEsMin.PerspectiveCamera(75, width / height, 0.1, 1000);
      var controls = new _ThreeEsMin.OrbitControls(camera, _this.mount);
      controls.autoRotate = _this.props.autoRotate;
      controls.pan = _this.props.pan;
      var renderer = new _ThreeEsMin.WebGLRenderer({
        antialias: _this.props.antialiasing,
        alpha: true
      });
      renderer.shadowMapEnabled = true;
      camera.position.z = _this.props.cameraDistance;
      renderer.autoClear = false;
      renderer.setClearColor(0x000000, 0.0);
      renderer.setSize(width, height);
      _this.controls = controls;
      _this.scene = scene;
      _this.camera = camera;
      _this.renderer = renderer;

      _this.loadMolecule(_this.props.url);

      window.addEventListener("resize", _this.resizeRenderer);

      _this.mount.appendChild(_this.renderer.domElement);

      _this.start();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "resizeRenderer", function (event) {
      _this.camera.aspect = window.innerWidth / window.innerHeight;

      _this.camera.updateProjectionMatrix();

      _this.renderer.setSize(_this.mount.clientWidth, _this.mount.clientHeight);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "start", function () {
      if (!_this.frameId) {
        _this.frameId = requestAnimationFrame(_this.animate);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "stop", function () {
      cancelAnimationFrame(_this.frameId);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "animate", function () {
      _this.renderScene();

      _this.frameId = window.requestAnimationFrame(_this.animate);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "loadMolecule", function (url) {
      var scope = _assertThisInitialized(_assertThisInitialized(_this));

      var vertexShader = ["precision highp float;", "uniform mat4 modelViewMatrix;", "uniform mat4 projectionMatrix;", "uniform mat4 normalMatrix;", "attribute vec2 uv;", "attribute vec3 position;", "attribute vec3 offset;", "attribute vec3 normal;", "varying vec2 vUv;", "varying vec3 vNormal;", "varying vec3 vPosition;", "void main() {", "vNormal = normal;", "vPosition = position;", "vUv = uv;", "gl_Position = projectionMatrix * modelViewMatrix * vec4( offset + position, 1.0 );", "}"].join("\n");
      var fragmentShader = ["precision highp float;", "varying vec3 vNormal;", "varying vec2 vUv;", "varying vec3 vPosition;", "uniform vec3 cameraPosition;", "void main() {", "", " gl_FragColor = vec4(normalize(vNormal), 1.0);", "", "}"].join("\n");
      var mat = new _ThreeEsMin.RawShaderMaterial({
        uniforms: {},
        vertexShader: vertexShader,
        fragmentShader: fragmentShader,
        side: _ThreeEsMin.DoubleSide,
        transparent: false
      });
      var loader = new _ThreeEsMin.PDBLoader();
      var offset = new _ThreeEsMin.Vector3();
      loader.load(url, function (pdb) {
        try {
          var geometryAtoms = pdb.geometryAtoms;
          var geometryBonds = pdb.geometryBonds;
          var json = pdb.json;
          var sphereGeometry = new _ThreeEsMin.IcosahedronBufferGeometry(1, 2);
          geometryAtoms.computeBoundingBox();
          geometryAtoms.boundingBox.getCenter(offset).negate();
          geometryAtoms.translate(offset.x, offset.y, offset.z);
          geometryBonds.translate(offset.x, offset.y, offset.z);
          var positions = geometryAtoms.getAttribute("position");
          var instances = positions.count;
          var position = new _ThreeEsMin.Vector4();
          var orientation = new _ThreeEsMin.Vector4();
          var offsets = [];
          var colors = [];
          var orientations = [];
          var x = 0,
              y = 0,
              z = 0;
          var geometry = new _ThreeEsMin.InstancedBufferGeometry().copy(sphereGeometry);
          geometry.attributes.position = sphereGeometry.attributes.position;
          geometry.attributes.offset = positions;
          geometry.attributes.uv = sphereGeometry.attributes.uv;
          geometry.computeBoundingBox();

          for (var i = 0; i < instances; i += 1 + scope.props.atomIncrement) {
            x = positions.getX(i) * scope.props.atomDistance;
            y = positions.getY(i) * scope.props.atomDistance;
            z = positions.getZ(i) * scope.props.atomDistance;
            offsets.push(x, y, z);
          }

          geometry.addAttribute('offset', new _ThreeEsMin.InstancedBufferAttribute(new Float32Array(offsets), 3));
          var mesh = new _ThreeEsMin.Mesh(geometry, mat);
          mesh.scale.multiplyScalar(scope.props.atomSize);
          scope.scene.add(mesh);
          scope.setState({
            loading: false
          });
        } catch (error) {
          console.log(error);
          scope.setState({
            useFallback: true,
            loading: false
          });
        }
      }, function (xhr) {}, function (err) {
        console.log(err);
        scope.setState({
          useFallback: true,
          loading: false
        });
      });
    });

    _this.state = {
      useFallback: false,
      loading: true
    };
    _this.rotating = true;
    _this.mouseX = 0;
    _this.mouseY = 0;
    _this.dragX = 0;
    _this.dragY = 0;
    _this.left = new _ThreeEsMin.Vector3(1, 0, 0);
    _this.up = new _ThreeEsMin.Vector3(0, 1, 0);
    return _this;
  }

  _createClass(PDBView, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (_ThreeEsMin.Detector.webgl) {
        this.startRendering();
      } else {
        this.setState({
          useFallback: true,
          loading: false
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.stop();
      this.mount.removeChild(this.renderer.domElement);
      this.controls.dispose();
      window.removeEventListener("resize", this.resizeRenderer);
    }
  }, {
    key: "componentDidCatch",
    value: function componentDidCatch(error, info) {
      this.setState({
        useFallback: true,
        loading: false
      });
    }
  }, {
    key: "renderScene",
    value: function renderScene() {
      this.controls.update();
      this.renderer.render(this.scene, this.camera);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement("div", {
        style: {
          width: this.props.width,
          height: this.props.height,
          display: "inline-block",
          margin: 0
        },
        className: this.props.className,
        ref: function ref(mount) {
          _this2.mount = mount;
        }
      }, this.state.loading ? this.props.loader : null, this.state.useFallback ? this.props.fallback : null);
    }
  }]);

  return PDBView;
}(_react.Component);

exports.default = PDBView;
PDBView.defaultProps = {
  atomIncrement: 0,
  atomSize: 1,
  atomDistance: 0.5,
  width: '400px',
  height: '400px',
  cameraDistance: 150,
  autoRotate: true,
  pan: true,
  loader: null,
  fallback: null
};